diff --git a/src/main/java/net/minecraft/client/gui/GuiStats.java b/src/main/java/net/minecraft/client/gui/GuiStats.java
index e171f1e5e..67b936327 100644
--- a/src/main/java/net/minecraft/client/gui/GuiStats.java
+++ b/src/main/java/net/minecraft/client/gui/GuiStats.java
@@ -693,48 +539,48 @@ public class GuiStats extends GuiScreen
         protected void renderHeader(int x, int y, Tessellator tessellator)
         {
             super.renderHeader(x, y, tessellator);
-            if(field_27268_b == 0)
+            if(clickedColumn == 0)
             {
-                func_27136_c(((x + 115) - 18) + 1, y + 1 + 1, 18, 18);
+                drawGuiIcon((x + COLUMN0_RIGHT) - STATS_ICON_SIZE + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/crafted"));
             } else
             {
-                func_27136_c((x + 115) - 18, y + 1, 18, 18);
+                drawGuiIcon((x + COLUMN0_RIGHT) - STATS_ICON_SIZE, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/crafted"));
             }
-            if(field_27268_b == 1)
+            if(clickedColumn == 1)
             {
-                func_27136_c(((x + 165) - 18) + 1, y + 1 + 1, 36, 18);
+                drawGuiIcon(((x + COLUMN1_RIGHT) - STATS_ICON_SIZE) + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/used"));
             } else
             {
-                func_27136_c((x + 165) - 18, y + 1, 36, 18);
+                drawGuiIcon(((x + COLUMN1_RIGHT) - STATS_ICON_SIZE), y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/used"));
             }
-            if(field_27268_b == 2)
+            if(clickedColumn == 2)
             {
-                func_27136_c(((x + 215) - 18) + 1, y + 1 + 1, 54, 18);
+                drawGuiIcon(((x + COLUMN2_RIGHT) - STATS_ICON_SIZE) + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/mined"));
             } else
             {
-                func_27136_c((x + 215) - 18, y + 1, 54, 18);
+                drawGuiIcon(((x + COLUMN2_RIGHT) - STATS_ICON_SIZE), y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/mined"));
             }
         }
 
         @Override
         protected void renderItem(int index, int x, int y, int height, Tessellator tessellator)
         {
-            StatItem statcrafting = func_27264_b(index);
-            int i1 = statcrafting.getItemID();
-            func_27138_c(x + 40, y, i1);
-            func_27265_a((StatItem)StatList.craftedItemStats[i1], x + 115, y, index % 2 == 0);
-            func_27265_a((StatItem)StatList.usedItemStats[i1], x + 165, y, index % 2 == 0);
-            func_27265_a(statcrafting, x + 215, y, index % 2 == 0);
+            StatItem statItem = getStat(index);
+            int id = statItem.getItem().id;
+            renderItemAsIcon(x + 40, y, id);
+            renderStatValue((StatItem) statItem.getItem().getStat(StatList.STAT_CRAFTED), x + COLUMN0_RIGHT, y, index % 2 == 0);
+            renderStatValue((StatItem) statItem.getItem().getStat(StatList.STAT_USED), x + COLUMN1_RIGHT, y, index % 2 == 0);
+            renderStatValue(statItem, x + COLUMN2_RIGHT, y, index % 2 == 0);
         }
 
         @Override
-        protected String func_27263_a(int i)
+        protected String getTooltipKey(int column)
         {
-            if(i == 0)
+            if(column == 0)
             {
                 return "stat.crafted";
             }
-            if(i == 1)
+            if(column == 1)
             {
                 return "stat.used";
             } else
diff --git a/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java b/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java
index bb5fcce88..3400102ce 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java
+++ b/src/main/java/net/minecraft/client/gui/GuiSwitchButton.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
-import net.minecraft.core.lang.I18n;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.lwjgl.opengl.GL11;
 
 public class GuiSwitchButton
@@ -56,16 +56,26 @@ public class GuiSwitchButton
         int state = getButtonState(mouseOver);
         int xBar = on ? (width / 3) + 1 : 0;
 
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/gui.png"));
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
+        IconCoordinate tex;
+        switch (state) {
+            case STATE_DISABLED:
+                tex = disabledTexture;
+                break;
+            case STATE_HOVERED:
+                tex = hoveredTexture;
+                break;
+            case STATE_DEFAULT:
+            default:
+                tex = defaultTexture;
+        }
+
         // Draw background
-        drawTexturedModalRect(xPosition, yPosition, 0, 46, width / 2, height);
-        drawTexturedModalRect(xPosition + width / 2, yPosition, 200 - width / 2, 46, width / 2, height);
+        drawGuiIcon(xPosition, yPosition, width, height, disabledTexture);
 
         // Draw foreground
-        drawTexturedModalRect(xPosition + xBar, yPosition, 0, 46 + state * 20, width / 3, height);
-        drawTexturedModalRect(xPosition + width / 3 + xBar, yPosition, 200 - width / 3, 46 + state * 20, width / 3, height);
+        drawGuiIcon(xPosition + xBar, yPosition, (width * 2)/3, height, tex);
 
         mouseDragged(mc, mouseX, mouseY);
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiTextureViewer.java b/src/main/java/net/minecraft/client/gui/GuiTextureViewer.java
new file mode 100644
index 000000000..f416f7538
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/GuiTextureViewer.java
@@ -0,0 +1,234 @@
+package net.minecraft.client.gui;
+
+import net.minecraft.client.GLAllocation;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.util.helper.Textures;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.Utils;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.opengl.GL11;
+
+import java.io.File;
+import java.util.ArrayList;
+import java.util.List;
+
+import static org.lwjgl.opengl.GL11.GL_BLEND;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_HEIGHT;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_WIDTH;
+import static org.lwjgl.opengl.GL11.glGetTexLevelParameteri;
+
+public class GuiTextureViewer extends GuiScreen{
+    private static final int TOP_SPACING = 24;
+    private static final int BUTTON_SPACING = 4;
+
+    protected int top;
+    protected int bottom;
+
+    protected GuiListenerButton leftTexCycle;
+
+    protected int texIndex = 0;
+
+    protected boolean drawCheckers = true;
+    protected boolean flip = false;
+    protected boolean drawText = true;
+
+    public GuiTextureViewer(GuiScreen parent) {
+        super(parent);
+    }
+
+    @Override
+    public void keyTyped(char c, int key, int mouseX, int mouseY)
+    {
+        if (key == Keyboard.KEY_LEFT) {
+            cycleTexture(-1);
+        } else if (key == Keyboard.KEY_RIGHT) {
+            cycleTexture(1);
+        } else if (key == Keyboard.KEY_ESCAPE) {
+            mc.displayGuiScreen(parentScreen);
+        }
+        List<GuiButton> _buttons = new ArrayList<>(controlList);
+        for (GuiButton button : _buttons){
+            if (button instanceof IListenerElement && button.isHovered(mouseX, mouseY)){
+                ((IListenerElement<?>) button).onKeyTyped(c, key);
+            }
+        }
+    }
+    @Override
+    public void tick(){
+        List<GuiButton> _buttons = new ArrayList<>(controlList);
+        for (GuiButton button : _buttons){
+            if (button instanceof GuiListenerButton){
+                ((GuiListenerButton) button).tick();
+            }
+        }
+    }
+    public void init()
+    {
+
+        top = TOP_SPACING;
+        bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
+        add(new GuiListenerButton(0, width/2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")).setActionListener(() -> {
+            onClosed();
+            mc.displayGuiScreen(null);
+        }));
+
+        leftTexCycle = add(new GuiListenerButton(1, width - (20 + BUTTON_SPACING) * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "<")
+            .setActionListener(() -> cycleTexture(-1)));
+        add(new GuiListenerButton(2, width - (20 + BUTTON_SPACING) * 1, bottom - (BUTTON_SPACING + 20), 20, 20, ">")
+            .setActionListener(() -> cycleTexture(1)));
+
+        add(new GuiListenerButton(11, BUTTON_SPACING, bottom - BUTTON_SPACING - 20, 20, 20, "V")
+            .setActionListener(() -> drawCheckers = !drawCheckers)
+        );
+        add(new GuiListenerButton(11, 20 + BUTTON_SPACING * 2, bottom - BUTTON_SPACING - 20, 20, 20, "F")
+            .setActionListener(() -> flip = !flip)
+        );
+        add(new GuiListenerButton(12, 40 + BUTTON_SPACING * 3, bottom - BUTTON_SPACING - 20, 20, 20, "D")
+            .setActionListener(() -> {
+                Textures.dumpTextures();
+                Utils.openDirectory(new File("dumpTextures"));
+            })
+        );
+        add(new GuiListenerButton(13, 60 + BUTTON_SPACING * 4, bottom - BUTTON_SPACING - 20, 20, 20, "T")
+            .setActionListener(() -> drawText = !drawText)
+        );
+    }
+
+    protected void buttonPressed(GuiButton button)
+    {
+    }
+
+    protected void buttonReleased(GuiButton button)
+    {
+    }
+
+    protected void cycleTexture(int offset) {
+        List<Integer> textureList = GLAllocation.textureNames;
+        texIndex += offset;
+        if (texIndex < 0) {
+            texIndex += textureList.size();
+        }
+        texIndex = texIndex % textureList.size();
+    }
+
+    public void drawScreen(int mouseX, int mouseY, float partialTick) {
+        drawDefaultBackground();
+
+        fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.texture_viewer.label.title"), width/2, 5, 0xFFFFFF);
+
+        List<Integer> textureList = GLAllocation.textureNames;
+        int id = texIndex % textureList.size();
+        GL11.glBindTexture(GL_TEXTURE_2D, textureList.get(id));
+
+        Texture t = mc.renderEngine.idToTextureMap.get(textureList.get(id));
+
+
+        GL11.glEnable(GL_BLEND);
+        GL11.glEnable(GL11.GL_DEPTH_TEST);
+
+        int texWidth = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH);
+        int texHeight = glGetTexLevelParameteri(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT);
+        double ratio = (double) texWidth / texHeight;
+
+        double imgHeight = (bottom - top - 40d);
+        double imgWidth = imgHeight * ratio;
+
+        if (imgWidth > width * 0.75) {
+            imgWidth = width * 0.75f;
+            imgHeight = imgWidth/ratio;
+        }
+
+        double x = (width - imgWidth)/2;
+        double y = (height - imgHeight)/2;
+
+        Tessellator tessellator = Tessellator.instance;
+
+        if (drawCheckers) {
+            mc.renderEngine.bindTexture(mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/designer_bg.png"));
+            tessellator.startDrawingQuads();
+            tessellator.addVertexWithUV(x + 0,         y + imgHeight,   zLevel, 0,          imgHeight/2);
+            tessellator.addVertexWithUV(x + imgWidth,  y + imgHeight,   zLevel, imgWidth/2, imgHeight/2);
+            tessellator.addVertexWithUV(x + imgWidth,  y + 0,           zLevel, imgWidth/2, 0);
+            tessellator.addVertexWithUV(x + 0,         y + 0,           zLevel, 0,          0);
+            tessellator.draw();
+        }
+
+        GL11.glBindTexture(GL_TEXTURE_2D, textureList.get(id));
+        tessellator.startDrawingQuads();
+        if (flip) {
+            tessellator.addVertexWithUV(x + 0,          y + imgHeight,  zLevel, 0, 0);
+            tessellator.addVertexWithUV(x + imgWidth,   y + imgHeight,  zLevel, 1, 0);
+            tessellator.addVertexWithUV(x + imgWidth,   y + 0,          zLevel, 1, 1);
+            tessellator.addVertexWithUV(x + 0,          y + 0,          zLevel, 0, 1);
+        } else {
+            tessellator.addVertexWithUV(x + 0,          y + imgHeight,  zLevel, 0, 1);
+            tessellator.addVertexWithUV(x + imgWidth,   y + imgHeight,  zLevel, 1, 1);
+            tessellator.addVertexWithUV(x + imgWidth,   y + 0,          zLevel, 1, 0);
+            tessellator.addVertexWithUV(x + 0,          y + 0,          zLevel, 0, 0);
+        }
+
+        tessellator.draw();
+
+//        int bw = (int) (250 + 100 * Math.sin(System.currentTimeMillis()/1000d));
+//        int bh = (int) (60 + 30 *  Math.cos(System.currentTimeMillis()/1000d));
+
+//        bw = 500;
+//        bh = 60;
+
+//        drawGuiIcon((width - bw)/2, (height - bh)/2, bw, bh, TextureRegistry.getTexture("minecraft:gui/widgets/button"));
+
+        super.drawScreen(mouseX, mouseY, partialTick);
+
+        GL11.glDisable(GL11.GL_DEPTH_TEST);
+
+        if (drawText) {
+            fontRenderer.drawString("Tex ID: " + id , 1, top + 1, 0xFFFFFF, true);
+            fontRenderer.drawString("Tex Width: " + texWidth, 1, top + 11, 0xFFFFFF, true);
+            fontRenderer.drawString("Tex Height: " + texHeight, 1, top + 21, 0xFFFFFF, true);
+
+            String s;
+            if (t == null) {
+                s = "None";
+            } else {
+                s = t.toString();
+            }
+            String[] lines = s.split("\n");
+            int yOff = top + 31;
+            for (String line : lines) {
+                fontRenderer.drawString(line, 1, yOff, 0xFFFFFF, true);
+                yOff += 10;
+            }
+        }
+    }
+    @Override
+    public void drawDefaultBackground() {
+        super.drawDefaultBackground();
+
+        if (mc.theWorld == null)
+        {
+            Tessellator tessellator = Tessellator.instance;
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            float scale = 32F;
+            tessellator.startDrawingQuads();
+            tessellator.setColorOpaque_I(0x202020);
+
+            tessellator.addVertexWithUV(0,      bottom, 0.0D,   0,              bottom / scale);
+            tessellator.addVertexWithUV(width,  bottom, 0.0D,   width / scale,  bottom / scale);
+            tessellator.addVertexWithUV(width,  top,    0.0D,   width / scale,  top / scale);
+            tessellator.addVertexWithUV(0,      top,    0.0D,   0,              top / scale);
+
+            tessellator.draw();
+        }
+        else
+        {
+            drawRect(0, 0, width, top, 0x5F000000);
+            drawRect(0, bottom, width, height, 0x5F000000);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/GuiTexturedButton.java b/src/main/java/net/minecraft/client/gui/GuiTexturedButton.java
index c2b7acbb0..e7f2e164f 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTexturedButton.java
+++ b/src/main/java/net/minecraft/client/gui/GuiTexturedButton.java
@@ -20,7 +20,7 @@ public class GuiTexturedButton extends GuiButton {
         if (!visible) {
             return;
         }
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture(texturePath));
+        mc.renderEngine.loadTexture(texturePath).bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         boolean isHovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         if (!enabled)
diff --git a/src/main/java/net/minecraft/client/gui/GuiTooltip.java b/src/main/java/net/minecraft/client/gui/GuiTooltip.java
index d3b64d572..c9a42285b 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTooltip.java
+++ b/src/main/java/net/minecraft/client/gui/GuiTooltip.java
@@ -9,10 +9,10 @@ import net.minecraft.client.option.enums.TooltipStyle;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotCrafting;
+import net.minecraft.core.player.inventory.slot.ResultSlot;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.player.inventory.slot.SlotGuidebook;
+import net.minecraft.core.player.inventory.slot.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -28,53 +28,78 @@ public class GuiTooltip extends Gui
         this.mc = mc;
         this.fr = mc.fontRenderer;
     }
+    public static final int BASE_PADDING = 3;
+    public static final int LINE_SPACING = 3;
 
     public void render(String string, int x, int y, int offsetX, int offsetY)
     {
         String[] lines = string.split("\n");
         if(lines.length == 0) return;
 
-        int lineSpacing = 3;
-        int padding = 3;
-
         int width = 0;
         for (String line : lines)
         {
             width = Math.max(width, fr.getStringWidth(line));
         }
 
-        int height = lines.length * 8 + (lines.length - 1) * lineSpacing;
+        int height = lines.length * 8 + (lines.length - 1) * LINE_SPACING;
 
         // Flip tooltip X if it goes offscreen to the right
-        if(x + offsetX + width + padding * 2 > mc.resolution.scaledWidth)
+        if(x + offsetX + width + BASE_PADDING * 2 > mc.resolution.scaledWidth)
         {
             offsetX = -offsetX - width;
         }
 
         // Move tooltip up when it goes offscreen to the bottom
-        offsetY -= Math.max(0, y + height + offsetY + padding * 2 - mc.resolution.scaledHeight);
+        offsetY -= Math.max(0, y + height + offsetY + BASE_PADDING * 2 - mc.resolution.scaledHeight);
+
 
         x += offsetX;
         y += offsetY;
 
+        int padding = getPadding();
+
+        drawBackground(x, y, x + width + padding * 2, y + height + padding * 2);
+
+
+        for(int i = 0; i < lines.length; i++)
+        {
+            fr.drawStringWithShadow(lines[i], x + padding, y + padding + i * (8 + LINE_SPACING), 0xFFFFFF);
+        }
+    }
+    public int getPadding(){
         int paddingExtra = 0;
         if (mc.gameSettings.tooltipStyle.value != TooltipStyle.DEFAULT)
         {
             paddingExtra = 1;
         }
-
-        drawBackground(x, y, x + width + padding * 2 + paddingExtra * 2, y + height + padding * 2 + paddingExtra * 2);
-        for(int i = 0; i < lines.length; i++)
+        return BASE_PADDING + paddingExtra;
+    }
+    public int[] drawBackground(int x, int y, int offsetX, int offsetY, int width, int height){
+        int targetOffset = 0;
+        // Flip tooltip X if it goes offscreen to the right
+        if(x + offsetX + width + BASE_PADDING * 2 > mc.resolution.scaledWidth)
         {
-            fr.drawStringWithShadow(lines[i], x + padding + paddingExtra, y + padding + i * (8 + lineSpacing) + paddingExtra, 0xFFFFFF);
+            int _offsetX = offsetX;
+            offsetX = -offsetX - width;
+            targetOffset = offsetX - _offsetX;
         }
+
+        // Move tooltip up when it goes offscreen to the bottom
+        offsetY -= Math.max(0, y + height + offsetY + BASE_PADDING * 2 - mc.resolution.scaledHeight);
+
+        x += offsetX;
+        y += offsetY;
+
+        int padding = getPadding();
+
+        return drawBackground(x, y, x + width + padding * 2, y + height + padding * 2);
     }
 
-    private void drawBackground(int minX, int minY, int maxX, int maxY)
+    private int[] drawBackground(int minX, int minY, int maxX, int maxY)
     {
         if(mc.gameSettings.tooltipStyle.value == TooltipStyle.MODERN) {
-        	drawBackgroundModern(minX, minY, maxX, maxY);
-        	return;
+        	return drawBackgroundModern(minX, minY, maxX, maxY);
         }
         
         int topLeftCornerX = minX;
@@ -92,7 +117,7 @@ public class GuiTooltip extends Gui
 
         Tessellator tl = Tessellator.instance;
 
-        mc.renderEngine.bindTexture(mc.renderEngine.getTexture(mc.gameSettings.tooltipStyle.value.getFilePath()));
+        mc.renderEngine.bindTexture(mc.renderEngine.loadTexture(mc.gameSettings.tooltipStyle.value.getFilePath()));
 
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
@@ -162,9 +187,10 @@ public class GuiTooltip extends Gui
         tl.draw();
 
         GL11.glDisable(GL11.GL_BLEND);
+        return new int[]{topLeftCornerX, topLeftCornerY};
     }
     
-    private void drawBackgroundModern(int minX, int minY, int maxX, int maxY) {
+    private int[] drawBackgroundModern(int minX, int minY, int maxX, int maxY) {
     	int x = minX + 4;
     	int y = minY + 4;
     	int width = maxX - minX - 8;
@@ -184,6 +210,7 @@ public class GuiTooltip extends Gui
 		drawGradientRect(x + width + 2, (y - 3) + 1, x + width + 3, (y + height + 3) - 1, lineColorTop, lineColorBottom);
 		drawGradientRect(x - 3, y - 3, x + width + 3, (y - 3) + 1, lineColorTop, lineColorTop);
 		drawGradientRect(x - 3, y + height + 2, x + width + 3, y + height + 3, lineColorBottom, lineColorBottom);
+        return new int[]{x - 3, y - 4};
     }
 
 	public String getTooltipText(ItemStack itemStack, boolean showDescription, Slot slot) {
@@ -197,7 +224,7 @@ public class GuiTooltip extends Gui
 		if(slot != null) {
 			discovered = slot.getIsDiscovered(mc.thePlayer);
 
-			if(slot instanceof SlotCrafting) {
+			if(slot instanceof ResultSlot) {
 				ctrlPressed = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
 				shiftPressed = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
 
@@ -219,13 +246,13 @@ public class GuiTooltip extends Gui
                 text.append(" #").append(itemStack.itemID).append(":").append(itemStack.getMetadata());
             }
 
-            if(slot instanceof SlotGuidebook){
-                if(((SlotGuidebook) slot).recipe != null) {
-                    if (((SlotGuidebook) slot).recipe instanceof RecipeEntryTrommel) {
-                        RecipeSymbol input = (RecipeSymbol) ((SlotGuidebook) slot).recipe.getInput();
-                        if(!input.matches(slot.getStack())){
-                            WeightedRandomBag<?> bag = (WeightedRandomBag<?>) ((SlotGuidebook) slot).recipe.getOutput();
-                            double percent = bag.getAsPercentage(slot.getStack());
+            if(slot instanceof GuidebookSlot){
+                if(((GuidebookSlot) slot).recipe != null) {
+                    if (((GuidebookSlot) slot).recipe instanceof RecipeEntryTrommel) {
+                        RecipeSymbol input = (RecipeSymbol) ((GuidebookSlot) slot).recipe.getInput();
+                        if(!input.matches(slot.getItem())){
+                            WeightedRandomBag<?> bag = (WeightedRandomBag<?>) ((GuidebookSlot) slot).recipe.getOutput();
+                            double percent = bag.getAsPercentage(slot.getItem());
                             text.append('\n').append(TextFormatting.LIGHT_GRAY).append(String.format("%.2f", percent)).append("%");
                         }
                     }
@@ -239,13 +266,13 @@ public class GuiTooltip extends Gui
 					text.append('\n').append(TextFormatting.LIGHT_GRAY).append("NBT: ").append(data.getValue().size()).append(" Tags");
 				}
 
-                if(slot instanceof SlotGuidebook){
-                    if(((SlotGuidebook) slot).recipe != null){
-                        text.append('\n').append(TextFormatting.GRAY).append(((SlotGuidebook) slot).recipe.toString());
+                if(slot instanceof GuidebookSlot){
+                    if(((GuidebookSlot) slot).recipe != null){
+                        text.append('\n').append(TextFormatting.GRAY).append(((GuidebookSlot) slot).recipe.toString());
                     }
-                    if(((SlotGuidebook) slot).symbol != null){
-                        if(((SlotGuidebook) slot).symbol.getItemGroup() != null){
-                            text.append('\n').append(TextFormatting.GRAY).append("Accepts any: ").append(((SlotGuidebook) slot).symbol.getItemGroup());
+                    if(((GuidebookSlot) slot).symbol != null){
+                        if(((GuidebookSlot) slot).symbol.getItemGroup() != null){
+                            text.append('\n').append(TextFormatting.GRAY).append("Accepts any: ").append(((GuidebookSlot) slot).symbol.getItemGroup());
                         }
                     }
                 }
@@ -262,7 +289,7 @@ public class GuiTooltip extends Gui
 				text.append('\n').append(formatDescription(itemStack.getItemDescription(), 16));
 			}
 
-			if(slot instanceof SlotCrafting) {
+			if(slot instanceof ResultSlot) {
 				if(shiftPressed && !ctrlPressed) {
 					text.append('\n').append(TextFormatting.LIGHT_GRAY).append("Craft Stack");
 				}
diff --git a/src/main/java/net/minecraft/client/gui/GuiTrommel.java b/src/main/java/net/minecraft/client/gui/GuiTrommel.java
index 793d0f229..76e24e647 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTrommel.java
+++ b/src/main/java/net/minecraft/client/gui/GuiTrommel.java
@@ -1,21 +1,21 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.core.block.entity.TrommelBlockEntity;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.inventory.ContainerTrommel;
-import net.minecraft.core.player.inventory.InventoryPlayer;
-import net.minecraft.core.block.entity.TileEntityTrommel;
+import net.minecraft.core.player.inventory.menu.TrommelMenu;
+import net.minecraft.core.player.inventory.container.Inventory;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
 //            GuiContainer, ContainerFurnace, FontRenderer, RenderEngine,
-//            TileEntityFurnace, InventoryPlayer
+//            FurnaceBlockEntity, InventoryPlayer
 
 public class GuiTrommel extends GuiContainer
 {
 
-    public GuiTrommel(InventoryPlayer inventoryplayer, TileEntityTrommel tileentitytrommel)
+    public GuiTrommel(Inventory inventoryplayer, TrommelBlockEntity tileentitytrommel)
     {
-        super(new ContainerTrommel(inventoryplayer, tileentitytrommel));
+        super(new TrommelMenu(inventoryplayer, tileentitytrommel));
         ySize = 192;
         trommelInventory = tileentitytrommel;
     }
@@ -30,9 +30,8 @@ public class GuiTrommel extends GuiContainer
     @Override
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
-        int guiTexture = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/trommel.png");
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(guiTexture);
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/trommel.png").bind();
         int j = (width - xSize) / 2;
         int k = (height - ySize) / 2;
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
@@ -49,5 +48,5 @@ public class GuiTrommel extends GuiContainer
 
     }
 
-    private TileEntityTrommel trommelInventory;
+    private TrommelBlockEntity trommelInventory;
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java b/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java
index 93585cd1a..e6dd56191 100644
--- a/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java
+++ b/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java
@@ -4,9 +4,9 @@ import net.minecraft.client.gui.popup.GuiPopup;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.Packet250CustomPayload;
+import net.minecraft.core.net.packet.CustomPayloadPacket;
 
 import java.lang.reflect.Modifier;
 import java.nio.charset.StandardCharsets;
@@ -29,7 +29,7 @@ public class GuiWandPickerMonster extends GuiScreen {
     public void init() {
         List<String> monsters = new ArrayList<>();
         for (Class<? extends Entity> clazz : EntityDispatcher.classToKeyMap.keySet()) {
-            if (EntityLiving.class.isAssignableFrom(clazz) && !Modifier.isAbstract(clazz.getModifiers())) {
+            if (Mob.class.isAssignableFrom(clazz) && !Modifier.isAbstract(clazz.getModifiers())) {
                 monsters.add(EntityDispatcher.classToKeyMap.get(clazz));
             }
         }
@@ -57,7 +57,7 @@ public class GuiWandPickerMonster extends GuiScreen {
                         if (!mc.theWorld.isClientSide) {
                             wand.getData().putString("monster", mobId);
                         } else {
-                            mc.getSendQueue().addToSendQueue(new Packet250CustomPayload("BTA|WandMonster", mobId.getBytes(StandardCharsets.UTF_8)));
+                            mc.getSendQueue().addToSendQueue(new CustomPayloadPacket("BTA|WandMonster", mobId.getBytes(StandardCharsets.UTF_8)));
                         }
                     }
                     shouldClose = true;
